/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.seguridad;

import com.rjconsultores.ventaboletos.entidad.Autorizacion;
import com.rjconsultores.ventaboletos.entidad.AutorizacionPerfil;
import com.rjconsultores.ventaboletos.entidad.Perfil;
import com.rjconsultores.ventaboletos.service.AutorizacionService;
import com.rjconsultores.ventaboletos.service.PerfilService;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderAutorizacionPerfil;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zul.Combobox;
import org.zkoss.zul.Comboitem;
import org.zkoss.zul.Paging;

/**
 *
 * @author Administrador
 */
@Controller("busquedaAutorizacionPerfilController")
@Scope("prototype")
public class BusquedaAutorizacionPerfilController extends MyGenericForwardComposer {

    @Autowired
    private transient PagedListWrapper<AutorizacionPerfil> plwAutorizacionPerfil;
    @Autowired
    private PerfilService perfilService;
    @Autowired
    private AutorizacionService autorizacionService;
    private List<Autorizacion> lsAutorizacion;
    private List<Perfil> lsPerfil;
    private MyListbox autorizacionPerfilList;
    private Paging pagingAutorizacionPerfil;
    private Combobox cmbPerfil;
    private Combobox cmbAutorizacion;

    public MyListbox getAutorizacionPerfilList() {
        return autorizacionPerfilList;
    }

    public void setAutorizacionPerfilList(MyListbox autorizacionPerfilList) {
        this.autorizacionPerfilList = autorizacionPerfilList;
    }

    public Combobox getCmbAutorizacion() {
        return cmbAutorizacion;
    }

    public void setCmbAutorizacion(Combobox cmbAutorizacion) {
        this.cmbAutorizacion = cmbAutorizacion;
    }

    public Combobox getCmbPerfil() {
        return cmbPerfil;
    }

    public void setCmbPerfil(Combobox cmbPerfil) {
        this.cmbPerfil = cmbPerfil;
    }

    public List<Autorizacion> getLsAutorizacion() {
        return lsAutorizacion;
    }

    public void setLsAutorizacion(List<Autorizacion> lsAutorizacion) {
        this.lsAutorizacion = lsAutorizacion;
    }

    public List<Perfil> getLsPerfil() {
        return lsPerfil;
    }

    public void setLsPerfil(List<Perfil> lsPerfil) {
        this.lsPerfil = lsPerfil;
    }

    public Paging getPagingAutorizacionPerfil() {
        return pagingAutorizacionPerfil;
    }

    public void setPagingAutorizacionPerfil(Paging pagingAutorizacionPerfil) {
        this.pagingAutorizacionPerfil = pagingAutorizacionPerfil;
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        lsAutorizacion = autorizacionService.obtenerTodos();
        lsPerfil = perfilService.obtenerTodos();

        super.doAfterCompose(comp);

        autorizacionPerfilList.setItemRenderer(new RenderAutorizacionPerfil());
        autorizacionPerfilList.addEventListener("onDoubleClick", new EventListener() {

            @Override
            public void onEvent(Event event) throws Exception {
                AutorizacionPerfil s = (AutorizacionPerfil) autorizacionPerfilList.getSelected();
                verAutorizacionPerfil(s);
            }
        });

        refreshLista();

        cmbAutorizacion.focus();
    }

    private void verAutorizacionPerfil(AutorizacionPerfil fs) {
        if (fs == null) {
            return;
        }

        Map args = new HashMap();
        args.put("autorizacionPerfil", fs);
        args.put("autorizacionPerfilList", autorizacionPerfilList);

        openWindow("/gui/seguridad/editarAutorizacionPerfil.zul",
                Labels.getLabel("editarAutorizacionPerfilController.window.title"), args, MODAL);
    }

    private void refreshLista() {
        HibernateSearchObject<AutorizacionPerfil> menuBusqueda =
                new HibernateSearchObject<AutorizacionPerfil>(AutorizacionPerfil.class,
                pagingAutorizacionPerfil.getPageSize());

        Comboitem cbiPerfil = cmbPerfil.getSelectedItem();
        if (cbiPerfil != null) {
            Perfil perfil = (Perfil) cbiPerfil.getValue();
            menuBusqueda.addFilterEqual("perfil", perfil);
        }

        Comboitem cbiAutorizacion = cmbAutorizacion.getSelectedItem();
        if (cbiAutorizacion != null) {
            Autorizacion autorizacion = (Autorizacion) cbiAutorizacion.getValue();
            menuBusqueda.addFilterEqual("autorizacion", autorizacion);
        }

        menuBusqueda.addSortAsc("autorizacion.nombautorizacion");
        menuBusqueda.addFilterEqual("activo", Boolean.TRUE);

        plwAutorizacionPerfil.init(menuBusqueda, autorizacionPerfilList,
                pagingAutorizacionPerfil);

        if (autorizacionPerfilList.getData().length == 0) {
            try {
                Messagebox.show(Labels.getLabel("MSG.ningunRegistro"),
                        Labels.getLabel("busquedaAutorizacionPerfilController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);
            } catch (InterruptedException ex) {
            }
        }
    }

    public void onClick$btnPesquisa(Event ev) {
        refreshLista();
    }

    public void onClick$btnRefresh(Event ev) {
        refreshLista();
    }

    public void onClick$btnNovo(Event ev) {
        verAutorizacionPerfil(new AutorizacionPerfil());
    }
}
